/****************************************************************************
 *	 TCC Version 0.6
 *	 Copyright (c) telechips, Inc.
 *	 ALL RIGHTS RESERVED
 *
****************************************************************************/
#define USE_VIQE
//#define USE_COPYBIT
//#define USE_CAMERA
#define USE_DUALOUTPUT

#if defined(USE_DUALOUTPUT)
//#define USE_DUALBUFFER
#endif

/* Memory Allocations */
#ifdef USE_DUALOUTPUT
#define PMEM_SURF_SIZE   					(32*1024*1024)
#else
#define PMEM_SURF_SIZE   					(16*1024*1024)
#endif
#ifdef USE_VIQE
#define PMEM_VIQE_SIZE   					(4*1024*1024)
#else
#define PMEM_VIQE_SIZE   					(0)
#endif
#ifdef USE_CAMERA
#define PMEM_CAM_SIZE   					(8*1024*1024)
#else
#define PMEM_CAM_SIZE   					(2*1024*1024)
#endif
#if defined(CONFIG_FB_TCC_OVERLAY_EXT) || defined(FB_TCC_OVERLAY_EXT)
#define OVERLAY_MEM_TOTAL_SIZE 				(24*1024*1024)
#else
#define OVERLAY_MEM_TOTAL_SIZE 				(12*1024*1024)
#endif
#if defined(CONFIG_TCC_MEM_512MB) || defined(TCC_MEM_512MB)
#define VIDEO_MEM_TOTAL_SIZE				(72*1024*1024)
#else
#define VIDEO_MEM_TOTAL_SIZE				(40*1024*1024)
#endif
#ifdef USE_COPYBIT
#define COPYBIT_MEM_SIZE					(2*1024*1024)
#else
#define COPYBIT_MEM_SIZE					(0)
#endif
#if defined(USE_DUALOUTPUT)
#define FB_VIDEO_MEM_SIZE					(8*1024*1024) 
#else
#define FB_VIDEO_MEM_SIZE					(0)
#endif
#if defined(USE_DUALOUTPUT)
#if defined(USE_DUALBUFFER)
#define FB_MEM_TOTAL_SIZE					(24*1024*1024)
#else
#define FB_MEM_TOTAL_SIZE					(12*1024*1024)
#endif
#else
#define FB_MEM_TOTAL_SIZE					(10*1024*1024)
#endif

#define TOTAL_FIXED_MEM_SIZE				(PMEM_SURF_SIZE+PMEM_VIQE_SIZE+PMEM_CAM_SIZE+OVERLAY_MEM_TOTAL_SIZE+VIDEO_MEM_TOTAL_SIZE+COPYBIT_MEM_SIZE+FB_VIDEO_MEM_SIZE +FB_MEM_TOTAL_SIZE)

#if defined(CONFIG_TCC_MEM_256MB) || defined(TCC_MEM_256MB) || defined(TCC_MEM_256MB_ST)
#define PMEM_SURF_BASE			  			(MEM_PHYS_OFFSET + TOTAL_SDRAM_SIZE - TOTAL_FIXED_MEM_SIZE)
#elif defined(CONFIG_TCC_MEM_512MB) || defined(TCC_MEM_512MB) || defined(TCC_MEM_512MB_ST)
#define PMEM_SURF_BASE			  			(MEM_PHYS_OFFSET + 0x0100000)
#endif

#define PMEM_VIQE_BASE				  		(PMEM_SURF_BASE + PMEM_SURF_SIZE)
#define PMEM_CAM_BASE			  			(PMEM_VIQE_BASE + PMEM_VIQE_SIZE)
#define OVERLAY_MEM_BASE					(PMEM_CAM_BASE + PMEM_CAM_SIZE)
#define VIDEO_MEM_BASE				  		(OVERLAY_MEM_BASE + OVERLAY_MEM_TOTAL_SIZE)
#define COPYBIT_MEM_BASE				  	(VIDEO_MEM_BASE + VIDEO_MEM_TOTAL_SIZE)
#define FB_VIDEO_MEM_BASE					(COPYBIT_MEM_BASE + COPYBIT_MEM_SIZE)
#define FB_MEM_BASE			  				(FB_VIDEO_MEM_BASE + FB_VIDEO_MEM_SIZE)

/*=============================================================================*/
#define PA_JPEG_RAW_BASE_ADDR				(VIDEO_MEM_BASE)
#define JPEG_RAW_MEM_SIZE					(0x1000000)

#define PA_JPEG_STREAM_BASE_ADDR			(VIDEO_MEM_BASE + JPEG_RAW_MEM_SIZE)
#define JPEG_STREAM_MEM_SIZE				(0x400000)
#define JPEG_TOTAL_MEM_SIZE      		 	(JPEG_RAW_MEM_SIZE + JPEG_STREAM_MEM_SIZE)

#define TCC_JPEG_HEADER_SIZE				(0x030000) 
#define PA_JPEG_HEADER_BASE_ADDR			(VIDEO_MEM_BASE + JPEG_TOTAL_MEM_SIZE - TCC_JPEG_HEADER_SIZE)

//for Camera
#define PREVIEW_MEM_SIZE					(PMEM_CAM_SIZE)
#define CAPTURE_MEM_SIZE      				(PMEM_CAM_SIZE)
#define PA_PREVIEW_BASE_ADDR				(PMEM_CAM_BASE)

//for Video
#define	VIDEO_PHY_ADDR 						(VIDEO_MEM_BASE)
#define VIDEO_MEM_SIZE						(VIDEO_MEM_TOTAL_SIZE)

//for Overlay
#define OVERLAY_TEMP_MEM_SIZE				(0x200000)

#if defined(CONFIG_FB_TCC_OVERLAY_EXT) || defined(FB_TCC_OVERLAY_EXT)
#define OVERLAY_SIZE_PER_DEVICE				(OVERLAY_MEM_TOTAL_SIZE/2)
#define OVERLAY_SIZE						(OVERLAY_SIZE_PER_DEVICE - OVERLAY_TEMP_MEM_SIZE)

#define OVERLAY_PHY_ADDR					(OVERLAY_MEM_BASE)
#define TEMP_PHY_ADDR						(OVERLAY_PHY_ADDR + OVERLAY_SIZE)
#define PRIOR_TEMP_PHY_ADDR					(TEMP_PHY_ADDR + OVERLAY_TEMP_MEM_SIZE/2)

#define OVERLAY1_PHY_ADDR					(OVERLAY_MEM_BASE + OVERLAY_SIZE_PER_DEVICE)
#define TEMP1_PHY_ADDR						(OVERLAY1_PHY_ADDR + OVERLAY_SIZE)
#define PRIOR_TEMP1_PHY_ADDR				(TEMP1_PHY_ADDR + OVERLAY_TEMP_MEM_SIZE/2)
	
#define CAM_OVERLAY_TEMP_ADDR				(TEMP1_PHY_ADDR)
#define CAM_OVERLAY_PRIOR_TEMP_ADDR			(PRIOR_TEMP1_PHY_ADDR)
#else
#define OVERLAY_PHY_ADDR					(OVERLAY_MEM_BASE)
#define OVERLAY_SIZE						(OVERLAY_MEM_TOTAL_SIZE - OVERLAY_TEMP_MEM_SIZE)
#define TEMP_PHY_ADDR						(OVERLAY_PHY_ADDR + OVERLAY_SIZE)
#define PRIOR_TEMP_PHY_ADDR					(TEMP_PHY_ADDR + OVERLAY_TEMP_MEM_SIZE/2)

#define CAM_OVERLAY_TEMP_ADDR				(TEMP_PHY_ADDR)
#define CAM_OVERLAY_PRIOR_TEMP_ADDR			(PRIOR_TEMP_PHY_ADDR)
#endif

// for FB hdmi display total 6Mbyte
#define HDMI_DISPLAY_MAX_WIDTH				1920
#define HDMI_DISPLAY_MAX_HEIGHT				1080
#define HDMI_DEC_MAX_WIDTH					1920
#define HDMI_DEC_MAX_HEIGHT					1080

#if defined(USE_DUALOUTPUT)
#define FB_G2D_WIDTH							1280
#define FB_G2D_HEIGHT							720
#else
#define FB_G2D_WIDTH							800
#define FB_G2D_HEIGHT							480
#endif


#if defined(USE_DUALOUTPUT) && defined(USE_DUALBUFFER)
#define FB_SCALE_SIZE						(HDMI_DISPLAY_MAX_WIDTH * HDMI_DISPLAY_MAX_HEIGHT *2)
#define FB_G2D_SIZE							(FB_G2D_WIDTH * FB_G2D_HEIGHT *2)

#define FB_SCALE_ADDR0						FB_MEM_BASE
#define FB_SCALE_ADDR1						(FB_SCALE_ADDR0 + FB_SCALE_SIZE)
#define FB_SCALE_ADDR2						(FB_SCALE_ADDR1 + FB_SCALE_SIZE)
#define FB_SCALE_ADDR3						(FB_SCALE_ADDR2 + FB_SCALE_SIZE)

#define FB_G2D_ADDR0						(FB_SCALE_ADDR3 + FB_SCALE_SIZE)
#define FB_G2D_ADDR1						(FB_G2D_ADDR0 + FB_G2D_SIZE)
#define FB_G2D_ADDR2						(FB_G2D_ADDR1 + FB_G2D_SIZE)
#define FB_G2D_ADDR3						(FB_G2D_ADDR2 + FB_G2D_SIZE)
#else //USE_DUALOUTPUT
#define FB_SCALE_SIZE						(HDMI_DISPLAY_MAX_WIDTH * HDMI_DISPLAY_MAX_HEIGHT *2)
#define FB_G2D_SIZE							(FB_G2D_WIDTH * FB_G2D_HEIGHT *2)

#define FB_SCALE_ADDR0						FB_MEM_BASE
#define FB_SCALE_ADDR1						(FB_SCALE_ADDR0 + FB_SCALE_SIZE)

#define FB_G2D_ADDR0						(FB_SCALE_ADDR1 + FB_SCALE_SIZE)
#define FB_G2D_ADDR1						(FB_G2D_ADDR0 + FB_G2D_SIZE)
#endif //USE_DUALOUTPUT

