/************************************************************************
*    Telechips Multi Media Player
*    ------------------------------------------------
*
*    FUNCTION    : ISP INTERFACE API
*    MODEL        : DMP
*    CPU NAME    : TCC93XX
*    SOURCE        : TCC_ISP_API.c
*
*    START DATE    : 2010. 2. 19.
*    MODIFY DATE :
*    DEVISION    : DEPT. SYSTEM BT 3 TEAM
*                : TELECHIPS, INC.
* 
************************************************************************/

//#define NUCLEUS_OS
#include "isp_interface.h"

#ifdef CAMERA_INCLUDE  
//#include "sensor_api.h"
#ifdef FEATURE_TCC_ISP

extern void *memcpy(void *dest, void *src, int n);
///////////////////////////////////////////////////
// etc
///////////////////////////////////////////////////
//#include "sensor/8M_Sony_IMX046ES.c"

HIsp 		g_hisp;
HEvent		g_hispevent;
HProfile 	g_hpreview;
HProfile 	g_hcapture;

DRVISPJpegInfo g_jpg_info;
extern DRVISPPreset *g_SensorPreset;

static unsigned char _g_hisp[DRVISP_HANDLER_SIZE];
static unsigned char _g_hispevent[DRVISP_HEVENT_SIZE];
static unsigned char _g_hpreview[DRVISP_HPROFILE_SIZE];
static unsigned char _g_hcapture[DRVISP_HPROFILE_SIZE];

static unsigned _g_drvispi2c = 0;

int ISP_SensorLoad( DRVISPPreset*** pPreset)
{
	*pPreset = &g_SensorPreset;
	return 0;
}	

///////////////////////////////////////////////////
// Device interface
///////////////////////////////////////////////////

int DRV_ISPI2C_Init(void)
{
	//MSGPRINTF(" DRV_I2C_Init()\n");

	return 0;
}

int DRV_ISPI2C_Write( unsigned slaveaddr, unsigned subaddr, unsigned data, unsigned mode)
{
	// i2c   motor drive ϴ 뵵 Ѵ.
	//   burst带   ̸ Ѵ.
	int iReturn = 0;
	MSGPRINTF(" DRV_I2C_Write()\n");

	return iReturn;
}

int DRV_ISPI2C_Read( unsigned slaveaddr, unsigned subaddr, unsigned *data, unsigned mode)
{
	// i2c   motor drive ϴ 뵵 Ѵ.
	int iReturn = 0;
	MSGPRINTF(" DRV_I2C_Read()\n");

	return iReturn;
}

int DRV_ISPI2C_Exit( )
{
	//  ȣ
	MSGPRINTF(" DRV_I2C_Exit()\n");

	return 0;
}

int DRV_INTC_Enable( unsigned mask )
{
	// ISP interrupt enable
	return 0;
}
int DRV_INTC_Disable( unsigned mask )
{
	// ISP interrupt disable
	return 0;
}

int DRV_CKC_Isp (unsigned clk)
{

	return 0;	
}

//  Ŭ 
int	DRV_SensorCkc(unsigned clk)
{
	MSGPRINTF(" isn't DRV_SensorCkc()\n");
	return 0;	
}

	//  reset pin 
int DRV_SensorReset(unsigned enable)
{
	MSGPRINTF(" isn't DRV_SensorReset()\n");
	if(enable) // Ҵ gpio   port Ư 𸣱  ӽ÷ 
	{
		//SENSOR_RESET_HIGH();
		//NU_Sleep(1);
		//SENSOR_RESET_LOW();
		//NU_Sleep(1);
		//SENSOR_RESET_HIGH();
		//NU_Sleep(1);
	}
	else
	{
		MSGPRINTF(" test_mipi_isp()\n");
		//init_sensor();
		//test_mipi_isp(); 
	}
	return 0;
}

	//  standby pin 
int DRV_SensorStandby(unsigned enable)
{
	MSGPRINTF(" isn't DRV_SensorStandby()\n");
//	if(enable)
//	{
//		SENSOR_PWRDN_ENABLE()
//	}
//	else
//	{
//		SENSOR_PWRDN_DISABLE()
//	}
	return 0;
}


int DRV_Flesh  (unsigned onoff)
{
	return 0;
}
int DRV_AFDrive(unsigned handle)
{
	return 0;
}
int DRV_Xenon  (unsigned handle)
{
	return 0;
}

// ISP state ̽ ȣ Ǵ Լ 
	// ó IOʱȭ  ȣ.
	// clk disable,  . GPIO 
int DRV_Trans_Init(HIsp hisp)
{
	int err;
		
	DRV_CKC_Isp (0);
	DRV_INTC_Disable( 0xffffffff );
	DRV_SensorCkc(0);
	DRV_SensorReset(1);
	DRV_SensorStandby(1);


	//err = drvisp_setstatus (hisp, DRVISPST_START);
	return err;
}

int DRV_Trans_Exit(HIsp hisp)
{
	int err;

	DRV_CKC_Isp (0);		
	DRV_INTC_Disable( 0xffffffff );
	DRV_SensorCkc(0);
	DRV_SensorReset(1);
	DRV_SensorStandby(1);
	
	return err;
}
int DRV_Trans_TurnOn(HIsp hisp)
{
	int err;
	{
		//  booting sequence ش delay time ؼ ڵ 
		DRV_SensorCkc(drvisp_getsensorclk(hisp));

		DRV_SensorReset(0);
		DRV_SensorStandby(0);
	}
	drvisp_loadpreset(hisp, DRVISPPRESET_INIT, 0, 0);

	return err;
}

int DRV_Trans_TurnOff(HIsp hisp)
{
	int err;

	//err = drvisp_setstatus (hisp, DRVISPST_START);

	{
		DRV_SensorCkc(0);
		DRV_SensorReset(1);
		DRV_SensorStandby(1);
	}
	drvisp_loadpreset(hisp, DRVISPPRESET_EXIT, 0, 0);	
	return err;
}

	// standby ¿ 
int DRV_Trans_WakeUp(HIsp hisp)
{
	int err;
	
	{
		DRV_SensorCkc(0);
		DRV_SensorStandby(0);
	}

	//err = drvisp_setstatus (hisp, DRVISPST_IDLE);
	return err;
}

	// standby  
int DRV_Trans_Sleep(HIsp hisp)
{
	int err;
	//err = drvisp_setstatus (hisp, DRVISPST_POWERDOWN);

	{
		DRV_SensorCkc(0);
		DRV_SensorStandby(1);
	}

	return err;
}

	// sensor data 
	// isp data ޾ frame buffer 
int DRV_Trans_Stream(HIsp hisp)
{
	int err;

	if (drvisp_sensoridx(hisp)) // 0 : first sensor, 1: second sensor
	{
		DRV_CKC_Isp ( drvisp_getclk(hisp) );
	}
	else
	{
		DRV_CKC_Isp ( drvisp_getclk(hisp) );
	}
	//err = drvisp_setstatus (hisp, DRVISPST_STREAMING);
	return err;
}	

	// sensor  ϳ,  data  .
	// mode ȯ    Ҹ
int DRV_Trans_Stop(HIsp hisp)
{
	int err;
	//err = drvisp_setstatus (hisp, DRVISPST_IDLE);

	DRV_CKC_Isp ( 0 );

	return err;
}

///////////////////////////////////////////////////
// Platform adaptation functions
///////////////////////////////////////////////////

// event handler
// mutex 
// task create / destroy
// memory allocation / free
// delay time 


int SAL_TimeDelay (int duration)
{

	return 0;
}

int SAL_TimeDelay_micro (int duration)
{

}
//inline unsigned SAL_getTickCount(unsigned *extra )
//{
//	return 0;
//}

///////////////////////////////////////////////////
// ISP_API
///////////////////////////////////////////////////


uint8 ISP_Init()
{
	int err;
	
	DRVISPCBFunc stcbfunc, *hcbfunc	;
	DRVISPPreset **hpreset;
	g_hisp = (HIsp) _g_hisp;
	g_hispevent = (HEvent) _g_hispevent;
	g_hpreview = (HProfile) _g_hpreview;
	g_hcapture = (HProfile) _g_hcapture;

	MSGPRINTF(" ISP_Init()\n");
	hcbfunc = &stcbfunc;
	hcbfunc->I2cInit = DRV_ISPI2C_Init;
	hcbfunc->I2cExit = DRV_ISPI2C_Exit;
	hcbfunc->I2cRead = DRV_ISPI2C_Read;
	hcbfunc->I2cWrite = DRV_ISPI2C_Write;
	hcbfunc->TransInit = DRV_Trans_Init;
	hcbfunc->TransExit = DRV_Trans_Exit;
	hcbfunc->TransTurnOn = DRV_Trans_TurnOn;
	hcbfunc->TransTurnOff = DRV_Trans_TurnOff;
	hcbfunc->TransWakeUp = DRV_Trans_WakeUp;
	hcbfunc->TransSleep = DRV_Trans_Sleep;
	hcbfunc->TransStream = DRV_Trans_Stream;
	hcbfunc->TransStop = DRV_Trans_Stop;
	hcbfunc->Flesh = DRV_Flesh;
	
	ISP_SensorLoad( &hpreset );

	err = drvisp_init( g_hisp, hpreset, hcbfunc );
	err = drvisp_makeevent( g_hisp, g_hispevent, 0);

	err = drvisp_makeprofile( g_hisp, g_hpreview, hpreset[DRVISPPRESET_PREVIEW],0);
	err = drvisp_makeprofile( g_hisp, g_hcapture, hpreset[DRVISPPRESET_CAPTURE],0);

#ifndef PARALLELCAMERA_MODE
	err = drvisp3A_init( g_hisp );
	err = drvispAdptvFunc_init( g_hisp );
#endif
	
    //drvisp_event3_setmask(DRVISPINT_IN_FRAME_END);
    //drvisp_event2_setmask(DRVISPINTMI_MP_FRAME_END | DRVISPINTMI_SP_FRAME_END);
    //drvisp_event4_setmask(DRVISPINTJPE_GEN_HEADER_DONE | DRVISPINTJPE_ENCODE_DONE);

	drvispevent_maskmipi(g_hispevent, DRVISPINTMIPI_FRAME_END);
	drvispevent_maskmi(g_hispevent, DRVISPINTMI_MP_FRAME_END | DRVISPINTMI_SP_FRAME_END);
	drvispevent_maskisp(g_hispevent, DRVISPINT_IN_FRAME_END | DRVISPINT_OUT_FRAME_END
							| DRVISPINT_EXP_END | DRVISPINT_AFM_FIN|DRVISPINT_PIC_ERR
							| DRVISPINT_AFM_LUM_OF | DRVISPINT_AFM_SUM_OF | DRVISPINT_ISP_OFF |DRVISPINT_VSTART);	
	/*drvispevent_maskjpe(g_hispevent, DRVISPINTJPE_VLC_TABLE_ERR 
							| DRVISPINTJPE_R2B_IMG_SIZE_ERR
							| DRVISPINTJPE_DCT_ERR
							| DRVISPINTJPE_VLC_SYMBOL_ERR
							| DRVISPINTJPE_ENCODE_DONE);
	*/						
	err = drvisp_setstatus (g_hisp, DRVISPST_IDLE);

	drvisp_setmode ( g_hisp, DRVISPMODE_PARALLEL_YUV , 0);

	return 0;
}

uint8 ISP_Exit()
{
	int err;
	MSGPRINTF(" ISP_Exit()\n");
	//err = DRV_Trans_TurnOff( g_hisp );
	err = drvisp_setstatus (g_hisp, DRVISPST_EMPTY);
#ifndef PARALLELCAMERA_MODE
	err = drvisp3A_exit( g_hisp );
	err = drvispAdptvFunc_exit( g_hisp );
#endif
	err = drvisp_exit( g_hisp );	
	return 0;
}

uint8 ISP_SetPreview_Control(uint8 status)
{
 	int err;
 	MSGPRINTF(" ISP_SetPreview_Control()\n");
 	if (status == TCC_ISP_PREVIEW_STATUS_START)
 	{
 		err = drvisp_setprofile (g_hisp, g_hpreview, DRVISPAPPLY_MODECHANGE);
#ifdef PARALLELCAMERA_MODE
		err = drvisp_setstatus(g_hisp, DRVISPST_STREAMING);
#else

	#ifndef PREV8M
		ConvPreIntTime();		
	#endif
		CapToPre = 5;			//STEVE to prevent break screen
		err = drvisp_setstatus(g_hisp, DRVISPST_STREAMING);
		drvisp3A_enable(g_hisp);  // STEVE 3A HOLD recovery
#endif
	}
	else
	{
#ifndef PARALLELCAMERA_MODE	
		drvisp3A_disable(g_hisp);
#endif
 		err = drvisp_setstatus(g_hisp, DRVISPST_IDLE);
 		{	int j;
			for (j=0; j<100000; j++) ;	// for test
		}

	}	
 	return err; 
}

uint8 ISP_Capture_Shooting(void)
{
	int err;
	MSGPRINTF(" ISP_Capture_Shooting()\n");

#ifndef PARALLELCAMERA_MODE
	drvisp3A_disable(g_hisp);  // STEVE 3A HOLD
#endif	
	err = drvisp_setstatus(g_hisp, DRVISPST_IDLE);
	err = drvisp_setprofile (g_hisp, g_hcapture, DRVISPAPPLY_MODECHANGE);
#ifndef PARALLELCAMERA_MODE
	ConvCapIntTime();
#endif
	{	int j;
		for (j=0; j<300000; j++) ;	// for test
	}

		
	err = drvisp_setstatus(g_hisp, DRVISPST_STREAMING);

	return err;	
}

///////////////////////////////////////////////////////////////////

uint8 ISP_SetPreviewH_Resolution(uint16 width, uint16 height)
{
	int err;	
	DRVISPRectSize size;

	size.width = width;
	size.height = height;
	
 	MSGPRINTF(" ISP_SetPreview_MainResolution()\n");
	err = drvispprofile_setmpath_size (g_hpreview, &size, DRVISPAPPLY_MODECHANGE); 

 	return 0; 
}

uint8 ISP_SetPreviewH_Format(FORMAT format)
{
	int err;
	switch (format)
	{
		case ISP_FORMAT_YUV422:
	#ifndef HV_YUV422SEQ			
			err = drvispprofile_setmpath_type (g_hpreview, DRVISPDTYPE_YCbCr422 | DRVISPDTYPE_PLANAR, 0); 
	#else
			err = drvispprofile_setmpath_type (g_hpreview, DRVISPDTYPE_YCbCr422 | DRVISPDTYPE_INTERLEAVED, 0); 	
	#endif
			break;
		case ISP_FORMAT_YUV420:
			err = drvispprofile_setmpath_type (g_hpreview, DRVISPDTYPE_YCbCr420 | DRVISPDTYPE_PLANAR, 0); 
			break;
		case ISP_FORMAT_RGB565:
		case ISP_FORMAT_BAYER:
		case ISP_FORMAT_JPEG:
		default:
				// invalid format
			err = 1;
			break;
	}
	return 0;
}


uint8 ISP_SetPreviewH_StartAddress(uint32 *y, uint32 *u, uint32 *v)
{
	int err;
	//err = drvispprofile_setmfb_addr(g_hpreview , (void*) y, (void*) u, (void*) v, DRVISPAPPLY_ENDOFFRAME);
	err = drvispprofile_setmfb_addr(g_hpreview , (void*) y, (void*) u, (void*) v, DRVISPAPPLY_IMMEDIATELY);
	return 0;
}

uint8 ISP_SetPreviewH_Size (uint32 szy, uint32 szu, uint32 szv)
{
	int err;
		
	err = drvispprofile_setmfb_size(g_hpreview , szy, szu, szv, DRVISPAPPLY_ENDOFFRAME);
	return 0;	
}

///////////////////////////////////////////////////////////////////

uint8 ISP_SetPreview_Resolution(uint16 width, uint16 height)
{
	int err;	
	DRVISPRegion region;
	region.offx = 0;
	region.offy = 0;
	region.width = width;
	region.height = height;
	region.xpitch = width;
	region.ypitch = height;
 	MSGPRINTF(" ISP_SetPreview_Resolution()\n");
	err = drvispprofile_setspath_region (g_hpreview, &region, DRVISPAPPLY_MODECHANGE); 
 	return 0; 
}

uint8 ISP_SetPreview_Format(FORMAT format)
{
	int err;
	switch (format)
	{
		case ISP_FORMAT_YUV422:
	#ifndef HV_YUV422SEQ			
			err = drvispprofile_setspath_type (g_hpreview, DRVISPDTYPE_YCbCr422 | DRVISPDTYPE_PLANAR, 0); 
	#else
			err = drvispprofile_setspath_type (g_hpreview, DRVISPDTYPE_YCbCr422 | DRVISPDTYPE_INTERLEAVED, 0); 	
	#endif
			break;
		case ISP_FORMAT_YUV420:
			err = drvispprofile_setspath_type (g_hpreview, DRVISPDTYPE_YCbCr420 | DRVISPDTYPE_PLANAR, 0); 
			break;
		case ISP_FORMAT_RGB565:
			err = drvispprofile_setspath_type (g_hpreview, DRVISPDTYPE_RGB565, 0); 
			break;
		case ISP_FORMAT_BAYER:
		case ISP_FORMAT_JPEG:
		default:
				// invalid format
			break;
	}
	return 0;
}


uint8 ISP_SetPreview_StartAddress(uint32 *y, uint32 *u, uint32 *v)
{
	int err;
	err = drvispprofile_setsfb_addr(g_hpreview , (void*) y, (void*) u, (void*) v, DRVISPAPPLY_ENDOFFRAME);
	return 0;
}

uint8 ISP_SetPreview_Size (uint32 szy, uint32 szu, uint32 szv)
{
	int err;
		
	err = drvispprofile_setsfb_size(g_hpreview , szy, szu, szv, DRVISPAPPLY_ENDOFFRAME);
	return 0;	
}


///////////////////////////////////////////////////////////////////

uint8 ISP_SetCapture_MainResolution(uint16 width, uint16 height)
{
	int err;	
	DRVISPRectSize size;

	size.width = width;
	size.height = height;
	
 	MSGPRINTF(" ISP_SetCapture_MainResolution()\n");
	err = drvispprofile_setmpath_size (g_hcapture, &size, DRVISPAPPLY_MODECHANGE); 
 	return 0; 
}

uint8 ISP_SetCapture_MainFormat(FORMAT format)
{
	int err;
	switch (format)
	{
		case ISP_FORMAT_YUV422:
			#ifndef HV_YUV422SEQ			
				err = drvispprofile_setmpath_type (g_hcapture, DRVISPDTYPE_YCbCr422 | DRVISPDTYPE_PLANAR, 0); 
			#else
				err = drvispprofile_setmpath_type (g_hcapture, DRVISPDTYPE_YCbCr422 | DRVISPDTYPE_INTERLEAVED, 0); 	
			#endif
			break;
		case ISP_FORMAT_YUV420:
			err = drvispprofile_setmpath_type (g_hcapture, DRVISPDTYPE_YCbCr420 | DRVISPDTYPE_PLANAR, 0); 
			break;
		case ISP_FORMAT_BAYER:
			err = drvispprofile_setmpath_type (g_hcapture, DRVISPDTYPE_RAW12, 0); 
			break;
		case ISP_FORMAT_JPEG:
			err = drvispprofile_setmpath_type (g_hcapture, DRVISPDTYPE_JPEG, 0); 
			break;
		case ISP_FORMAT_RGB565:
		default:
				// invalid format
			err = 1;
			break;
	}
	return 0;
}

uint8 ISP_SetCapture_MainImageStartAddress(uint32 *y, uint32 *u, uint32 *v)
{
	int err;
	err = drvispprofile_setmfb_addr(g_hcapture , (void*) y, (void*) u, (void*) v, DRVISPAPPLY_ENDOFFRAME);
	return 0;
}


uint8 ISP_SetCapture_MainImageSize (uint32 szy, uint32 szu, uint32 szv)
{
	int err;
		
	err = drvispprofile_setmfb_size(g_hcapture , szy, szu, szv, DRVISPAPPLY_ENDOFFRAME);
	return 0;	
}


///////////////////////////////////////////////////////////////////

uint8 ISP_SetCapture_ThumbResolution(uint16 width, uint16 height)
{
	int err;	
	DRVISPRegion region;
	region.offx = 0;
	region.offy = 0;
	region.width = width;
	region.height = height;
	region.xpitch = width;
	region.ypitch = height;
 	MSGPRINTF(" ISP_SetCapture_ThumbResolution()\n");
	err = drvispprofile_setspath_region (g_hcapture, &region, DRVISPAPPLY_MODECHANGE); 	
 	return 0; 
}
uint8 ISP_SetCapture_ThumbFormat(FORMAT format)
{
	int err;
	switch (format)
	{
		case ISP_FORMAT_YUV422:
			#ifndef HV_YUV422SEQ			
				err = drvispprofile_setspath_type (g_hcapture, DRVISPDTYPE_YCbCr422 | DRVISPDTYPE_PLANAR, 0); 
			#else
				err = drvispprofile_setspath_type (g_hcapture, DRVISPDTYPE_YCbCr422 | DRVISPDTYPE_INTERLEAVED, 0); 	
			#endif
			break;
		case ISP_FORMAT_YUV420:
			err = drvispprofile_setspath_type (g_hcapture, DRVISPDTYPE_YCbCr420 | DRVISPDTYPE_PLANAR, 0); 
			break;
		case ISP_FORMAT_RGB565:
			err = drvispprofile_setspath_type (g_hcapture, DRVISPDTYPE_RGB565, 0); 
			break;
		case ISP_FORMAT_BAYER:
		case ISP_FORMAT_JPEG:
		default:
			// invalid format
			err = 1;
			break;
	}
	return 0;
}

uint8 ISP_SetCapture_ThumbImageStartAddress(uint32 *y, uint32 *u, uint32 *v)
{
	int err;
	err = drvispprofile_setsfb_addr(g_hcapture , (void*) y, (void*) u, (void*) v, DRVISPAPPLY_ENDOFFRAME);
	return 0;
}

uint8 ISP_SetCapture_ThumbImageSize (uint32 szy, uint32 szu, uint32 szv)
{
	int err;
		
	err = drvispprofile_setsfb_size(g_hcapture , szy, szu, szv, DRVISPAPPLY_ENDOFFRAME);
	return 0;	
}

uint8 ISP_getJpeg_ExifData(ISPJpegInfo* jpg_info)
{
	MSGPRINTF(" ISP_getJpeg_ExifData()\n");
	drvisp_getjpeginfo(g_hisp, 0,0,&g_jpg_info);
	memcpy(jpg_info, (ISPJpegInfo*)&g_jpg_info, sizeof(ISPJpegInfo));

	return 1;
}

uint8 ISP_SetCapture_MultiShotCount(uint8 count)
{
	int err;
	MSGPRINTF(" ISP_SetCapture_MultiShotCount()\n");
	err = drvispprofile_setmpath_number(g_hcapture, count, -1); 
	return 1;
}

uint8 ISP_Stop_Irq()
{
	int err;
	MSGPRINTF(" ISP_Stop_Irq()\n");	
	drvisp_stop_irq_apply(g_hisp);
	return 1;		
}


/* : not yet by lee k
uint32 ISP_GetCapture_MainImage_Length(void)
{
	uint32 length;
	MSGPRINTF(" ISP_GetCapture_MainImage_Length()\n");
	return length;	
}

uint32 ISP_GetCapture_ThumbImage_Length(void)
{
	uint32 length;
	MSGPRINTF(" ISP_GetCapture_ThumbImage_Length()\n");
	return length;
}

uint8 ISP_SetCapture_MultiShotCount(uint8 count)
{
	int err;
	MSGPRINTF(" ISP_SetCapture_MultiShotCount()\n");
	err = drvispprofile_setmpath_number(g_hcapture, count, -1); 
	return 1;
}

uint8 ISP_SetRollingCapture_JumpingLine(uint32 line_pixels)
{
	MSGPRINTF(" ISP_SetRollingCapture_JumpingLine()\n");
	return 1;
}

uint8 ISP_SetRollingCapture_InterruptLine(uint32 line_int)
{
	MSGPRINTF(" ISP_SetRollingCapture_InterruptLine()\n");
	return 1;
}

uint8 ISP_SetJpegQuality(JPEG_QUALITY quality)
{
	int err;
	MSGPRINTF(" ISP_SetJpegQuality()\n");
	err = drvispprofile_setjpeg(_g_hcapture, quality, 0);
	return 1;
}

uint8 ISP_getJpeg_ExifData(void* raw_data)
{
	MSGPRINTF(" ISP_getJpeg_ExifData()\n");
	return 1;
}

not yet by lee k */


/*****************************************************************
  ISP COMMON LIST  
*****************************************************************/  
uint8 ISP_SetPreview_Window(uint16 sx, uint16 sy, uint16 width, uint16 height)
{
	int err;
	DRVISPRect window;
	window.offx = sx;
	window.offy = sy;
	window.width = width;
	window.height = height;
	MSGPRINTF(" ISP_SetPreviewWindow()\n");
	err = drvispprofile_setwindow(g_hpreview, &window , DRVISPAPPLY_ENDOFFRAME);			
	return 0;
}

uint8 ISP_SetCapture_Window(uint16 sx, uint16 sy, uint16 width, uint16 height)
{
	int err;
	DRVISPRect window;
	window.offx = sx;
	window.offy = sy;
	window.width = width;
	window.height = height;
	MSGPRINTF(" ISP_SetCaptureWindow()\n");
	err = drvispprofile_setwindow(g_hcapture, &window , DRVISPAPPLY_ENDOFFRAME);			
	return 0;
}

uint8 ISP_SetCapture_MakeZoomTable(uint16 stepx, uint16 stepy, uint16 width, uint16 height, uint16 number)
{
	int err;
	int i;
	DRVISPRect zoom;

	MSGPRINTF(" ISP_SetCapture_MakeZoomTable\n");

	for (i=0; i < number; i++)
	{
		zoom.offx =		stepx*i;
		zoom.offy =		stepy*i;
		zoom.width =	width - zoom.offx*2;
		zoom.height =	height - zoom.offy*2;
		
		err = drvispprofile_setzoomtbl(g_hcapture, i, &zoom, 0);	
		if (err)	break;			
	}
	return 0;
}

uint8 ISP_SetPreview_MakeZoomTable(uint16 stepx, uint16 stepy, uint16 width, uint16 height, uint16 number)
{
	int err = 0;
	int i;
	DRVISPRect zoom;

	MSGPRINTF(" ISP_SetPreview_MakeZoomTable\n");
	
	for (i=0; i < number; i++)
	{
		zoom.offx =		stepx*i;
		zoom.offy =		stepy*i;
		zoom.width =	width - zoom.offx*2;
		zoom.height =	height - zoom.offy*2;
		
		err = drvispprofile_setzoomtbl(g_hpreview, i, &zoom, 0);

		#if 0
		{
			int j;
			unsigned short *pdata;
			pdata = &g_hpreview->sctbl[0];				
			dbg_printf("0x%04x ",i);
			for (j=0; j< 24; j++)
			{

				dbg_printf("0x%04x ",*pdata);
			}
			dbg_printf("\n");
		}		
		#endif
		if (err)	break;			
	}
	return 0;
}

uint8 ISP_SetPreview_Zoom(uint16 zoom)
{
	int err;
	MSGPRINTF(" ISP_SetPreview_Zoom(%d)\n",zoom);
	err = drvispprofile_setzoom(g_hpreview, zoom, DRVISPAPPLY_LATER);	
	return 0;
}

uint8 ISP_SetCapture_Zoom(uint16 zoom)
{
	int err;
	MSGPRINTF(" ISP_SetCapture_Zoom(%d)\n",zoom);
	err = drvispprofile_setzoom(g_hcapture, zoom, DRVISPAPPLY_MODECHANGE);	
	return 0;
}


uint8 ISP_SetContrast(uint8 level)
{
	int err;
	MSGPRINTF(" ISP_SetContrast(%d)\n",level);
	
	err = drvispprofile_setcontrast(g_hcapture, level, DRVISPAPPLY_MODECHANGE );
	err = drvispprofile_setcontrast(g_hpreview, level, DRVISPAPPLY_ENDOFFRAME );

	return 0;
}

uint8 ISP_SetBrightness(uint8 level)
{
	int err;
	MSGPRINTF(" ISP_SetBrightness(%d)\n",level);
	
	err = drvispprofile_setbrightness(g_hcapture, level, DRVISPAPPLY_MODECHANGE );
	err = drvispprofile_setbrightness(g_hpreview, level, DRVISPAPPLY_ENDOFFRAME );

	return 0;
}

uint8 ISP_SetSaturation(uint8 level)
{
	int err;
	MSGPRINTF(" ISP_SetSaturation(%d)\n",level);
	
	err = drvispprofile_setsaturation(g_hcapture, level, DRVISPAPPLY_MODECHANGE );
	err = drvispprofile_setsaturation(g_hpreview, level, DRVISPAPPLY_ENDOFFRAME );

	return 0;
}

uint8 ISP_SetHue(uint8 level)
{
	int err;
	MSGPRINTF(" ISP_SetHue(%d)\n",level);
	
	err = drvispprofile_sethue(g_hcapture, level, DRVISPAPPLY_MODECHANGE );
	err = drvispprofile_sethue(g_hpreview, level, DRVISPAPPLY_ENDOFFRAME );

	return 0;
}

uint8 ISP_SetImg_Effect(IMAGE_EFFECT effectID)
{
	int err;
	MSGPRINTF(" ISP_SetImg_Effect(%d)\n",effectID);
	err = drvispprofile_setie(g_hcapture, effectID, 0, 0, DRVISPAPPLY_MODECHANGE);
	err = drvispprofile_setie(g_hpreview, effectID, 0, 0, DRVISPAPPLY_ENDOFFRAME);

	return 1;
}

/* : not yet by lee k

uint8 ISP_SetExposure_Mode(EXPOSURE_MODE_TYPE mode)
{
	MSGPRINTF(" ISP_SetExposure_Mode()\n");
	return 1;
}

uint8 ISP_SetAutoExposure_Windowtype(AE_WINTYPE type)
{
	MSGPRINTF(" ISP_SetAutoExposure_Windowtype()\n");
	return 1;
}

uint8 ISP_SetISO(AE_ISO iso)
{
	MSGPRINTF(" ISP_SetISO()\n");
	return 1;
}

uint8 ISP_SetAWB(AWB_MODE mode)
{
	MSGPRINTF(" ISP_SetAWB()\n");
	return 1;
}

uint8 ISP_AE_AWB_Lock(uint8 AE_enable, uint8 AWB_enable)
{
	MSGPRINTF(" ISP_AE_AWB_Lock()\n");
	return 1;
}

uint8 ISP_SetAutoFocus_Mode(AF_MODE_TYPE mode)
{
	MSGPRINTF(" ISP_SetAutoFocus_Mode()\n");
	return 1;
}

uint8 ISP_SetAutoFocus_Control(uint8 ctrl_cmd)
{
	MSGPRINTF(" ISP_SetAutoFocus_Control()\n");
	return 1;
}

AF_STATUS_RESULT ISP_GetAutoFocus_Status(void)
{
	AF_STATUS_RESULT result;
	MSGPRINTF(" ISP_GetAutoFocus_Status()\n");
	return result;
}

uint8 ISP_SetSceneMode(SCENE_MODE scene)
{
	MSGPRINTF(" ISP_SetSceneMode()\n");
	return 1;
}

uint8 ISP_SetWDR(uint8 enable)
{
	MSGPRINTF(" ISP_SetWDR()\n");
	return 1;
}



uint8 ISP_SetFlickerMode(FLICKER_MODE mode)
{
	MSGPRINTF(" ISP_SetFlickerMode()\n");
	return 1;
}

LIGHT_COND ISP_GetLowlight_Condition(void)
{
	LIGHT_COND result;
	MSGPRINTF(" ISP_GetLowlight_Condition()\n");	
	return result;
}

uint8 ISP_SetColorTemperature(LIGHT_TEMP Temp)
{
	MSGPRINTF(" ISP_SetColorTemperature()\n");
	return 1;
}

LIGHT_TEMP ISP_GetColorTemperature(void)
{
	LIGHT_TEMP result;
	MSGPRINTF(" ISP_GetColorTemperature()\n");
	return result;
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
uint8 ISP_SetSyncPolarity(uint8 Hsync, uint8 Vsync)
{
	MSGPRINTF(" ISP_SetSyncPolarity()\n");
	return 1;
}


uint8 ISP_SetRotate(ROTATE_TYPE Rotate_type)
{
	MSGPRINTF(" ISP_SetRotate()\n");
	return 1;
}

uint8 ISP_SetSharpness(uint8 level)
{
	MSGPRINTF(" ISP_SetSharpness()\n");
	return 1;
}

uint8 ISP_SetSmooth(uint8 level)
{
	MSGPRINTF(" ISP_SetSmooth()\n");
	return 1;
}

uint8 ISP_SetSaturation(uint8 level)
{
	MSGPRINTF(" ISP_SetSaturation()\n");
	return 1;
}

uint8 ISP_SetContrast(uint8 level)
{
	MSGPRINTF(" ISP_SetContrast()\n");
	return 1;
}

void ISP_SetNoiseReduction(uint8 onoff)
{
	MSGPRINTF(" ISP_SetNoiseReduction()\n");
}

void ISP_SetHistogram(uint8 onoff)
{
	MSGPRINTF(" ISP_SetHistogram()\n");
}

void ISP_GetHistogram_values(uint8 * value[])
{
	MSGPRINTF(" ISP_GetHistogram_values()\n");
}

uint8 ISP_SetFlashControl(FLASH_CTRL_TYPE flash_ctrl)
{
	MSGPRINTF(" ISP_SetFlashControl()\n");
	return 1;
}

//////////// ????????????????????????????????????????????????
//////////// ????????????????????????????????????????????????

uint8 ISP_CheckStatusForCmd(void)
{
	MSGPRINTF(" ISP_CheckStatusForCmd()\n");
	return 1;
}


uint8 ISP_SetFaceDetection(FD_STATUS status)
{
	MSGPRINTF(" ISP_SetFaceDetection()\n");
	return 1;
}

uint8 ISP_SetImageStabilizer_Mode(ISC_MODE mode)
{
	MSGPRINTF(" ISP_SetImageStabilizer_Mode()\n");
	return 1;
}

uint8 ISP_SetImageStabilizer_Count(uint8 count)
{
	MSGPRINTF(" ISP_SetImageStabilizer_Count()\n");
	return 1;
}
 not yet by lee k  */

///////////////////////////////////////////////////
// ISP process
///////////////////////////////////////////////////

// MASK_ISPINT_OUT_FRAME_END event ߻ϸ ﰢ Ѵ.
int ISP_Process(void)
{
	int err;
#ifndef PARALLELCAMERA_MODE
	
	// todo :  Ȯ 
	if (drvispevent_ctrlisp(g_hispevent,  DRVISPINT_EXP_END))
	{		
		err = drvisp3A_process(g_hisp, 1, 0, 0);
		err = drvispAdptvFunc_process(g_hisp, 1, 0, 0);
	}

	if (drvispevent_ctrlisp(g_hispevent,  DRVISPINT_IN_FRAME_END))
	{		
		err = drvisp3A_process(g_hisp, 0, 0, 0);
		err = drvispAdptvFunc_process(g_hisp, 0,0,0);
	}
#endif	
	return 0;
}

//int ISPTask_Exit(void)
//{
//
//}

///////////////////////////////////////////////////
// Event handler
///////////////////////////////////////////////////
#ifdef FEATURE_TCC_ISP
//extern int T3A_Run(unsigned a);

unsigned char test=0;
void HISR_ISP_INT2_Handler(void)
{
	ISP_Process();
}
#endif //FEATURE_TCC_ISP


// ISP interrupt Ҹ Լ. ʱȭ .
// for mipi
int ISP_EventHandler1_getEvent(unsigned event)
{
	return drvispevent_ctrlmipi(g_hispevent, event);
}
void ISP_EventHandler1(void)
{
	drvisp_irq1_noti( g_hisp );
}

// ISP interrupt Ҹ Լ. ʱȭ .
// for mi
int ISP_EventHandler2_getEvent(unsigned event)
{
	return drvispevent_ctrlmi(g_hispevent, event);
}
void ISP_EventHandler2(void)
{
	drvisp_irq2_noti( g_hisp );
#if 0
	if (drvispevent_ctrlmi(g_hispevent, DRVISPINTMI_MP_FRAME_END))
	{		
		// to do
		// main path image Ϸ. 뿡 event .

	}
	if (drvispevent_ctrlmi(g_hispevent, DRVISPINTMI_SP_FRAME_END))
	{		
		// to do
		// self path image Ϸ. 뿡 event .
#ifdef NUCLEUS_OS
		DEV_LCDC_SetImageBase(1/*LCD_LC*/, 2/*IMG_CH0*/, 
			HwISP(0x143c) + HwISP(0x1448) ,
			HwISP(0x1450) + HwISP(0x145c) ,
			HwISP(0x1460) + HwISP(0x146c) 	);
		DEV_LCDC_SetImageCtrl(1/*LCD_LC*/, 0, 2/*IMG_CH0*/, 0);
#else  // NON_OS
#endif  // #ifdef NUCLEUS_OS
	}	
#endif	
}

extern unsigned int Tc_AF_FV_calc(void);
	
// ISP interrupt Ҹ Լ. ʱȭ .
// for isp
int ISP_EventHandler3_getEvent(unsigned event)
{
	return drvispevent_ctrlisp(g_hispevent, event);
}
void ISP_EventHandler3(void)
{	
	drvisp_irq3_noti( g_hisp );

	if (drvispevent_ctrlisp(g_hispevent, DRVISPINT_AFM_FIN))
	{		

	}
}

// ISP interrupt Ҹ Լ. ʱȭ .
// for jpeg
int ISP_EventHandler4_getEvent(unsigned event)
{
	return drvispevent_ctrljpe(g_hispevent, event);
}
void ISP_EventHandler4(void)
{
	drvisp_irq4_noti( g_hisp );
}


////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////

void ISP_SetInterrupt()
{
	MSGPRINTF(" ISP_SetInterrupt()\n");
#ifdef NUCLEUS_OS
	BITSET(HwPIC->IEN1, HwINT1_SPI0);    
	BITSET(HwPIC->SEL1, HwINT1_SPI0);

	BITSET(HwPIC->IEN1, HwINT1_SPI1);    
	BITSET(HwPIC->SEL1, HwINT1_SPI1);
	

	BITSET(HwPIC->IEN0, HwINT0_ISP2);    
	BITSET(HwPIC->SEL0, HwINT0_ISP2);

	BITSET(HwPIC->IEN1, HwINT1_ISP3);    
	BITSET(HwPIC->SEL1, HwINT1_ISP3);
#else

#endif	//#ifdef NUCLEUS_OS
}
	
void ISP_ClearInterrupt()
{
	MSGPRINTF(" ISP_clearInterrupt()\n");
#ifdef NUCLEUS_OS
	BITCLR(HwPIC->IEN1, HwINT1_SPI0);    
	BITCLR(HwPIC->IEN1, HwINT1_SPI1);    
	BITCLR(HwPIC->IEN0, HwINT0_ISP2);    
	BITCLR(HwPIC->IEN1, HwINT1_ISP3);    
#else

#endif	//#ifdef NUCLEUS_OS
	
}	

#endif 		//#ifdef FEATURE_TCC_ISP
#endif		// #ifdef CAMERA_INCLUDE  

