#ifndef	_LCDC_H_
#define	_LCDC_H_  

#define SCREEN_WIDTH			320
#define SCREEN_HEIGHT			480

#define	LCD_CH	1
#define	IMG_CH0	2
#define	IMG_CH1	4
#define	IMG_CH2	8

#define	IMG_LIT_ENDIAN		((0x0)<<7)
#define	IMG_BIG_ENDIAN		((0x1)<<7)
#define	IMG_RGB				((0x0)<<4)
#define	IMG_YUV420			((0x1)<<4)
#define	IMG_YUV422			((0x3)<<4)
#define	IMG_YUV422_DISP		((0x7)<<4)
#define	IMG_BPP_1			((0x0)<<0)
#define	IMG_BPP_2			((0x1)<<0)
#define	IMG_BPP_4			((0x2)<<0)
#define	IMG_BPP_332			((0x3)<<0)
#define	IMG_BPP_444			((0x4)<<0)
#define	IMG_BPP_565			((0x5)<<0)
#define	IMG_BPP_555			((0x6)<<0)
#define	IMG_BPP_888			((0x7)<<0)
#define	IMG_BPP_666			((0x8)<<0)
#define	IMG_BITPADDING		((0x1)<<15)

#define	PXDW_4				((0x0))
#define	PXDW_8				((0x1))
#define	PXDW_888			((0x2))
#define	PXDW_565			((0x3))
#define	PXDW_555			((0x4))
#define	PXDW_18				((0x5))
#define	PXDW_8_UY_SEQ		((0x6))
#define	PXDW_8_VY_SEQ		((0x7))
#define	PXDW_16_YU_SEQ		((0x8))
#define	PXDW_16_YV_SEQ		((0x9))
                        													
#define LSCALE1				((0x0))																									
#define LSCALE2				((0x1))																									
#define LSCALE3				((0x2))																									
#define LSCALE4				((0x3))																									
#define LSCALE8				((0x7))																									

#define	LCDSI_WRITE 		0x00000001
#define	LCDSI_READ			0x00000002

#define	LCDSI_CS00 			0x00000001
#define	LCDSI_CS01 			0x00000002
#define LCDSI_CS10 			0x00000004
#define	LCDSI_CS11 			0x00000008

#define	LCDSI_MIF_8BITS 	0
#define	LCDSI_MIF_9BITS		1
#define LCDSI_MIF_16BITS0	2
#define	LCDSI_MIF_16BITS1 	3

#define	CPU_MODE			0
#define	LCDC_MODE			1
#define	IF80				0
#define	IF68				1

#define	DELAY_300ns		6
#define	DELAY_50us		500
#define	DELAY_1ms			10000
#define	DELAY_5ms			50000
#define	DELAY_10ms		100000
#define	DELAY_20ms		200000
#define	DELAY_30ms		300000
#define	DELAY_40ms		400000
#define	DELAY_50ms		500000
#define	DELAY_90ms		900000
#define	DELAY_100ms		1000000

#define	FMT565_8BIT			0    
#define	FMT565_16BIT		6
#define	FMT888_8BIT			1    
#define	FMT888_9BIT			3    
#define	FMT888_16BIT_1		5
#define	FMT888_16BIT_2		7
#define	FMT666_16BIT_1		8
#define	FMT666_16BIT_2		10
#define	FMT666_16BIT_3		12

#define	LCDSI_RS_HIGH		1
#define	LCDSI_RS_LOW		0

#define	LCDSI_CS0			0
#define	LCDSI_CS1			1

#define	LCD_ROT0L			0
#define	LCD_ROT90L			1
#define	LCD_ROT180L			2
#define	LCD_ROT270L			3
#define	LCD_MIR_ROT0L		10
#define	LCD_MIR_ROT90L		11
#define	LCD_MIR_ROT180L		12
#define	LCD_MIR_ROT270L		13

#define	LCD_CLR8			1
#define	LCD_CLR262144		0

#define SET_IMAGE_SIZE			0x00000001
#define SET_IMAGE_POSITION		0x00000002
#define SET_IMAGE_OFFSET		0x00000004
#define SET_IMAGE_SCALE			0x00000008
#define SET_IMAGE_FORMAT		0x00000010
#define READ_IMAGE_POSITION		0x00000020
#define SET_IMAGE_ALL			0x0000003F
#define SET_LCD_POLARITY		0x00000040
#define SET_LCD_MASK			0x00000080
#define SET_LCD_ALL				0x000000C0

#define PAGE0						0
#define PAGE1						1

#define SET_LCD_ENABLE				0x00000001
#define SET_LCD_DISABLE				0x00000002
#define SET_CH0_ENABLE				0x00000004
#define SET_CH0_DISABLE				0x00000008
#define SET_CH1_ENABLE				0x00000010
#define SET_CH1_DISABLE				0x00000020
#define SET_CH2_ENABLE				0x00000040
#define SET_CH2_DISABLE				0x00000080
#define SET_TFT_ENABLE				0x00000100
#define SET_TFT_DISABLE				0x00000200
#define SET_TVOUT_ENABLE			0x00000400
#define SET_TVOUT_DISABLE			0x00000800
#define SET_STN_ENABLE				0x00001000
#define SET_STN_DISABLE				0x00002000
#define SET_NOTINTERLACE_ENABLE		0x00004000
#define SET_NOTINTERLACE_DISABLE	0x00008000
#define SET_DP2_ENABLE				0x00010000
#define SET_DP2_DISABLE				0x00020000
#define SET_RGB2YUV_ENABLE			0x00040000
#define SET_RGB2YUV_DISABLE			0x00080000
#define SET_CCIR656_ENABLE			0x00100000
#define SET_CCIR656_DISABLE			0x00200000
#define SET_CH0YUV2RGB_ENABLE		0x00400000
#define SET_CH0YUV2RGB_DISABLE		0x00800000
#define SET_CH1CHROMA_ENABLE		0x01000000
#define SET_CH1CHROMA_DISABLE		0x02000000
#define SET_CH2CHROMA_ENABLE		0x04000000
#define SET_CH2CHROMA_DISABLE		0x08000000
#define SET_CH1ALPHA_ENABLE			0x10000000
#define SET_CH1ALPHA_DISABLE		0x20000000
#define SET_CH2ALPHA_ENABLE			0x40000000
#define SET_CH2ALPHA_DISABLE		0x80000000

#define SET_PXDW4_ENABLE			0x00000001
#define SET_PXDW8_ENABLE			0x00000002
#define SET_PXDW888_ENABLE			0x00000004
#define SET_PXDW565_ENABLE			0x00000008
#define SET_PXDW555_ENABLE			0x00000010
#define SET_PXDW18_ENABLE			0x00000020
#define SET_PXDW8UY_ENABLE			0x00000040
#define SET_PXDW8VY_ENABLE			0x00000080
#define SET_PXDW16YU_ENABLE			0x00000100
#define SET_PXDW16YV_ENABLE			0x00000200
#define SET_PXDW888_RGB_GRB_ENABLE	0x00000400
#define SET_PXDW888_GRB_RGB_ENABLE	0x00000800
#define SET_PXDW888_24BIT_ENABLE		0x00001000
#define SET_PXDW888_DUMMY_ENABLE	0x00002000

#define SET_BPP1_ENABLE				0x00000400
#define SET_BPP2_ENABLE				0x00000800
#define SET_BPP4_ENABLE				0x00001000
#define SET_BPP332_ENABLE			0x00002000
#define SET_BPP444_ENABLE			0x00004000
#define SET_BPP565_ENABLE			0x00008000
#define SET_BPP555_ENABLE			0x00010000
#define SET_BPP888_ENABLE			0x00020000
	
#define SET_MASTER_DMA0				0x00040000
#define SET_MASTER_DMA1				0x00080000 

#define SET_LCDSI_OUTPUTMODE		0x00000001
#define READ_LCDSI_INPUTMODE		0x00000002
#define SET_LCDSI_INPUTMODE			0x00000004
#define SET_LCDSI_FORMAT			0x00000008
#define SET_LCDSI_RESPONCE			0x00000010
#define SET_LCDSI_CS				0x00000020
#define SET_LCDSI_IA				0x00000040
#define SET_LCDSI_IVS				0x00000080
#define SET_LCDSI_ALL				0x000000FF

#define SET_LCD_ALPHA_VALUE			0x00000001
#define SET_LCD_KEY_BLUE			0x00000002
#define SET_LCD_KEY_GREEN			0x00000004
#define SET_LCD_KEY_RED				0x00000008
#define SET_LCD_ALPHAMASK_VALUE		0x00000010
#define SET_LCD_KEYMASK_BLUE		0x00000020
#define SET_LCD_KEYMASK_GREEN		0x00000040
#define SET_LCD_KEYMASK_RED			0x00000080
#define SET_LCD_ALPHAMASK_TYPE		0x00000100

#define SET_LCD_KEY_ALL				0x000000FF

#define SET_0_TRANSPARENCY		0x0
#define SET_30_TRANSPARENCY		0x1
#define SET_60_TRANSPARENCY		0x2
#define SET_90_TRANSPARENCY		0x3

#define	SET_DL_REGUPDATE_EN		0x00000001
#define SET_DL_LCD_OP_EN		0x00000002
#define	SET_DL_CONF_START_ADDR0	0x00000004
#define	SET_DL_CONF_START_ADDR1 0x00000008
#define	SET_DL_CONV_PARAM_Y		0x00000010
#define SET_DL_CONV_PARAM_CR2	0x00000020
#define SET_DL_CONV_PARAM_CR1	0x00000040
#define SET_DL_CONV_PARAM_CB2	0x00000080
#define SET_DL_CONV_PARAM_CB1	0x00000100
#define SET_DL_ALL				0x000001FF   

typedef enum{
	LCDC_ALPHA100 = 0x0,			// 100 % (back ground image)
	LCDC_ALPHA93P75 = 0x1,		// 93.75%
	LCDC_ALPHA87P5 = 0x2,		// 87.5%
	LCDC_ALPHA81P25 = 0x3,		// 81.25%
	LCDC_ALPHA75 = 0x4,			// 75%
	LCDC_ALPHA68P75 = 0x5,		// 68.75%		
	LCDC_ALPHA62P5 = 0x6,		// 62.5%
	LCDC_ALPHA56P25 = 0x7,		// 56.25%
	LCDC_ALPHA50 = 0x8,			// 50%
	LCDC_ALPHA43P75 = 0x9,		// 43.75%
	LCDC_ALPHA37P5 = 0xA,		// 37.5%		
	LCDC_ALPHA31P25 = 0xB,		// 31.25%
	LCDC_ALPHA25 = 0xC,			// 25%
	LCDC_ALPHA18P75 =0x0D ,		// 18.75%		
	LCDC_ALPHA12P5 = 0xE,		// 12.5%
	LCDC_ALPHA6P25 = 0xF,		// 6.25%
}LCDC_AlphaValue;



typedef enum{
	LCDC_ALPHA_VALUE = 0,
	LCDC_ALPHA_PIXVALUE = 1
}LCDC_AlphaType;

typedef enum{
	YUV2RGBType0,
	YUV2RGBType1,
	YUV2RGBType2,
	YUV2RGBType3
}LCDC_YUV2RGBType;


extern	void LCDC_SetHTime (unsigned int uiPulseWidth, unsigned int uiStartCount, unsigned int uiWidth, unsigned int uiEndCount);
extern	void LCDC_SetClipping (unsigned int	uiUpperLimitY, unsigned int uiLowerLimitY, unsigned int uiUpperLimitUV, unsigned int uiLowerLimitUV);

extern void LCDC_SetVTime (unsigned int uiVSyncPulseWidth, unsigned int uiFrameStartWaitCycle, unsigned int	uiHeight, unsigned int uiFrameEndWaitCycle, unsigned int uiVSyncPulseWidth1, unsigned int uiFrameStartWaitCycle1, unsigned int uiHeight1, unsigned int	uiFrameEndWaitCycle1, unsigned int uiFVSyncDelay, unsigned int uiBVSyncDelay);
extern void LCDC_SetClock (unsigned int uiCS, unsigned int uiPxClkDiv, unsigned int uiLclkDiv,  unsigned int uiACDiv);
extern void LCDC_SetOverlayPriority(unsigned int uiPriority);
extern void LCDC_DualLCDControl(unsigned int uiFlag, unsigned int uiRegUpEn, unsigned int uiOpEn, unsigned int uiCfgStAddr0, 
								unsigned int uiCfgStAddr1, unsigned int uiConvParamY, unsigned int uiConvParamCR2,
								unsigned int uiConvParamCR1, unsigned int uiConvParamCB2, unsigned int uiConvParamRCr);

extern void LCDC_SetImageBase (unsigned int uiType, unsigned int uiBase0, unsigned int uiBase1, unsigned int uiBase2);
extern unsigned int LCDC_SetImageInfo (unsigned int uiFlag, unsigned int uiType, unsigned int uiWidth, unsigned int uiHeight, unsigned int uiHPos, unsigned int uiVPos, unsigned int uiHOffset0, unsigned int uiHOffset1, unsigned int uiHScale, unsigned int uiVScale, unsigned int uiFormat);
extern void LCDC_SetMaskAndPolarity (unsigned int uiFlag, unsigned int uiHsync, unsigned int uiVsync, unsigned int uiClockPulse, unsigned int uiACBias, unsigned int uiDd, unsigned int uiFu, unsigned int uiRu);
extern void LCDC_SetBackgroundColor(unsigned int uiColorRV, unsigned int uiColorGU, unsigned int uiColorBY);
extern void LCDC_SetControlInfo(unsigned int uiPage, unsigned int uiFlag);
extern int LCD_SetBlockExtOut(int flag);
extern int LCD_SetUpdateExtOut(int flag);
extern void LCDC_SetImageOverlayKey (unsigned int uiFlag, unsigned int uiType, LCDC_AlphaValue uiAlpha, unsigned int uiKeyRed, unsigned int uiKeyGreen, unsigned int uiKeyBlue, LCDC_AlphaValue uiAlphaMask, unsigned int uiKeyMaskRed, unsigned int uiKeyMaskGreen, unsigned int uiKeyMaskBlue);
extern void	LCDC_SetAlphatype (unsigned int uiType, LCDC_AlphaType uiAlpha_type);
extern void	LCDC_SetYUV2RGBtype (unsigned int uiType, LCDC_YUV2RGBType coverter_type);



extern unsigned int LCDSI_DATA_Read(unsigned int uiCS);

extern void LCDC_LookUpTable_Init(void);

extern void LCDC_SET_INTTERUPT(char onoff);

#endif //_LCDC_H_


