/*
 * include/linux/mfd/lp8725.h
 *
 * Copyright (C) 2009 Telechips, Inc.
 *
 * This software is licensed under the terms of the GNU General Public
 * License version 2, as published by the Free Software Foundation, and
 * may be copied, distributed, and modified under those terms.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef __LINUX_MFD_LP8725_H
#define __LINUX_MFD_LP8725_H

#include <linux/i2c.h>
#include <linux/platform_device.h>
#include <linux/regulator/lp8725.h>

struct lp8725 {
	struct i2c_client *client;
	struct mutex lock;

	struct platform_device regulators[LP8725_NUM_REGULATORS];
};

int lp8725_reg_read(struct lp8725 *lp8725, u8 reg);
int lp8725_reg_write(struct lp8725 *lp8725, u8 reg, u8 val);
int lp8725_reg_set_bit_mask(struct lp8725 *lp8725, u8 reg, u8 mask, u8 val);

#endif
