/****************************************************************************
 *   FileName    : tca_tcchwcontrol.h
 *   Description : 
 ****************************************************************************
 *
 *   TCC Version 1.0
 *   Copyright (c) Telechips, Inc.
 *   ALL RIGHTS RESERVED
 *
 ****************************************************************************/
#ifndef __TCA_TCCHWCONTROL_H__
#define __TCA_TCCHWCONTROL_H__

#ifdef __cplusplus
extern "C" {
#endif

/*****************************************************************************
*
* Defines
*
******************************************************************************/

#define	AUDIO_DMA_PAGE_SIZE		(1024)					// Size in bytes
#define	AUDIO_DMA_IN_PAGE_SIZE	(1024)					// Size in bytes


#if defined(_TCC79x_)
#define	HwDADI_L0_PHYSICAL	*(volatile unsigned long *)0xF0059000	// R, Digital Audio Left Input Register 0
#define	HwDADO_L0_PHYSICAL	*(volatile unsigned long *)0xF0059020	// R/W, Digital Audio Left output Register 0
#elif defined(_TCC83x_)
#define	HwDADI_L0_PHYSICAL	*(volatile unsigned long *)0x90000000	// R, Digital Audio Left Input Register 0
#define	HwDADO_L0_PHYSICAL	*(volatile unsigned long *)0x90000020	// R/W, Digital Audio Left output Register 0
#endif


//i2s control api
extern unsigned int tca_i2s_init(unsigned int,unsigned int);
extern unsigned int tca_i2s_deinit(void);
extern unsigned int tca_i2s_setregister(unsigned int nRegval);
extern unsigned int tca_i2s_getregister(void);

extern void tca_i2s_start(unsigned int nMode);
extern void tca_i2s_stop(unsigned int nMode);
extern void tca_i2s_initoutput(unsigned int);
extern void tca_i2s_initintput(unsigned int);
extern void tca_i2s_mutecontrol(unsigned int nMode);

//Get IRQ GetNumber
extern unsigned int tca_irq_getnumber(void);

//dma control api
extern unsigned int tca_dma_clrstatus(unsigned int nDmanum);
extern unsigned int tca_dma_getstatus(unsigned int nDmanum);
extern unsigned int tca_dma_control(unsigned int nMode,unsigned int nDmanum,unsigned int nInMode);
extern unsigned int tca_dma_setsrcaddr(unsigned int nDmanum, unsigned int nAddr);
extern unsigned int tca_dma_setdestaddr(unsigned int nDmanum, unsigned int nAddr);
extern unsigned int tca_dma_clrinterrupt(unsigned nDmanum);

//GPIO port INIT
extern unsigned int tca_tcc_initport(void);

extern void tea_i2s_setclock(unsigned int ClockRate);
#ifdef __cplusplus
}
#endif
//#define _USING_ADMA_

#endif

