#=======================================================================================
#	FileName    : tcc_mkrd.sh
#	Description : Make linux.rom
#                 Mark linux.rom with CRC & ramdisk size
#=======================================================================================
#
#	TCC Board Support Package
#	Copyright (c) Telechips, Inc.
#	ALL RIGHTS RESERVED
#
#=======================================================================================

source .config

#
# ramdisk.rom size (MByte)
#
RAMDISK_SIZE=4

echo
echo "======================================================"
if test $CONFIG_ARCH_TCC79X; then
	if test $CONFIG_MACH_TCC7901S; then
		RAMDISK_SIZE=8
		echo -e "[\x1b[1;33mTelechips TCC79S\x1b[0m]"
	else
		echo -e "[\x1b[1;33mTelechips TCC79X\x1b[0m]"
	fi
fi

if test $CONFIG_ARCH_TCC83X; then
echo -e "[\x1b[1;33mTelechips TCC83X\x1b[0m]"
fi

# make linux.img
echo
echo -e "[\x1b[1;33mMAKE\x1b[0m] \x1b[1;31mlinux.rom\x1b[0m"
dd if=arch/arm/boot/Image of=linux.img bs=5M conv=sync

# insert CRC & ramdisk.rom size
echo
echo -e "[\x1b[1;33mMARK\x1b[0m] CRC & ramdisk size \x1b[1;31m$RAMDISK_SIZE\x1b[0m Mbyte"
./tcc_crc -o linux.rom -v 1700 -r $RAMDISK_SIZE linux.img


# remove Img, linux.img
rm -f linux.img
echo "======================================================"
echo

exit
